/* circuit window
*/
class CWin {
public:
	TrieStor<int> ins, outs;
	TrieStor<CWinEdge *> edges; // neighbors with non-zero connection with this window
private:
	int id; // index
	Gate *gateB, *gateE;
	int gateN;
public:
	CWin(int id, Gate *);
	~CWin();
	int getId() const;
	Gate *getGates() const;
	int getGateN() const;
	void mergeIO(const CWin *, const TrieStor<int> &primOuts, TrieStor<CWin *> &neighbors,
		TrieStor<int> &workIns, TrieStor<int> &workOuts, TrieStor<int> &workIsect) const;
	void merge(CWin *, const TrieStor<int> &primOuts, TrieStor<CWin *> &neighbors,
		TrieStor<int> &workIns, TrieStor<int> &workOuts, TrieStor<int> &workIsect);
	void removeEdges();
private:
	void getNeighbors(const CWin *, TrieStor<CWin *> &res) const; // of these cwins, except themselves
};
