template<typename T>
class TrieStor {
private:
	vector<int> trie;
	vector<T> data;
private: // specializations
	void reset_0();
	int getPos(const T &) const;
	int getPosA(const T &); // appends the val into trie
public:
	TrieStor();
	void reset();
	void reserveTrie(int);
	void reserveData(int);
	const vector<int> &getTrie() const;
	const vector<T> &getData() const;
	unsigned size() const;
	bool add(const T &);
	bool remove(const T &);
	int getI(const T &) const;
	bool find(const T &) const;
	const T &operator[](int i) const;
	TrieStor<T> &operator=(const TrieStor<T> &x);
	TrieStor<T> &operator+=(const TrieStor<T> &x);
	TrieStor<T> &operator-=(const TrieStor<T> &x);
	bool isect(const TrieStor<T> &x, const TrieStor<T> &y);
private:
	void reset_str();
	void newNode();
	int getPos_key(const char *, int n) const;
	int getPosA_key(const char *, int n);
	int getPos_str(const string &) const;
	int getPosA_str(const string &);
};
