#define ARGI_INFILE "input .blif file"

#define ARG_OUTFILE "-o"
#define ARGI_OUTFILE "output .blif file"

#define ARG_CWIN "-n"
#define ARGI_CWIN "number of windows to make in the circuit"
#define ARGD_CWIN 4 // defaults

#define ARG_CWIN_WG "-w"
#define ARGI_CWIN_WG "weights for i/o counts and number of gates in a window"
#define ARGD_CWIN_WG1 1
#define ARGD_CWIN_WG2 1
#define ARGD_CWIN_WG3 0

#define ARG_RWIN_WG "-r"
#define ARGI_RWIN_WG "weights for number of gates, gate inputs and levels in resynthesized window"
#define ARGD_RWIN_WG1 1
#define ARGD_RWIN_WG2 1
#define ARGD_RWIN_WG3 3

#define ARG_METHODS "-m"
#define ARGI_METHODS "file with resynthesis methods"

#define ARG_FORCE "-force"
#define ARGI_FORCE "force remaining commands, when resynthesis method fails"

#define ARG_RSEED "-rand"
#define ARGI_RSEED "random seed"

#define ARG_NOT_CLEAR "-nclear"
#define ARGI_NOT_CLEAR "not delete working files"

#define ARG_LOG "-log"
#define ARGI_LOG "logging for all events"

#define ARG_NO_WARNINGS "-nwarn"
#define ARGI_NO_WARNINGS "no warnings"

#define ERR_FOPEN "File opening error"
#define ERR_BLIF "Damaged blif file"
#define ERR_MUTEX "Invalid mutex message"

#define NO_INDEX -1
#define BOSS_RANK 0

#define TAG_COMMON 0
#define TAG_MUTEX 1

#define FILE_CWIN "_cw" // circuit window
#define FILE_METHOD "_m" // i/o for resynthesis using a method
#define FILE_OUTPUT "_o" // the best output

#define CIRC_NODE "n" // for local signals (node + its index)

#define WAIT_FOPEN 0.01 // basic time to the next open try [s]
#define WAIT_FOPEN_C 1.05 // delay multiplier
#define WAIT_MAX 2 // satured delay [s]
#define WAIT_PHASE 2 // time scale for waiting based on rank [s]
#define WAIT_ERROR 2 // after errors, for logging [s]

#define MTD_IOFILE "IO_FILE"
#define MTD_LIST "METHODS"

#define BLIF_COMMENT "#"
#define BLIF_KEYWORD "."
#define BLIF_MODEL ".model"
#define BLIF_INS ".inputs"
#define BLIF_OUTS ".outputs"
#define BLIF_NAMES ".names"
#define BLIF_END ".end"

#define BLIF_DMODEL ".model Default"

#define TRIE_STRING_COEF 6.0 // average ratio of trie items and numbered labels, actually 5.8
#define TRIE_INT_COEF 3.2 // for ascending numbers with an offset, actually 3.0

#define LEVEL_FRESH -1 // unevaluated gate

/* circuit states
*/
#define CIRC_ST_CREATED 0
#define CIRC_ST_LOADED 1
#define CIRC_ST_CWINS 2 // circuit windows made
#define CIRC_ST_SPLITTED 3
#define CIRC_ST_MERGED 4

#define MUTEX_PASSIVE 0 // outside process waiting in the lock method
#define MUTEX_ACTIVE 1 // process in the lock competition
#define MUTEX_PROBE 2 // passive, active?
#define MUTEX_WINNER 3 // winner of the lock competition
#define MUTEX_TICKET 4 // ticket to pass the lock, given from leaving process
#define MUTEX_POKE 5 // to unblock a process in a possible deadlock

#define BOSS_JOB_FILE "rusinluk_dip_BOSS_JOB" // working file for non-blocking jobs of the boss
#define BOSS_JOB_WAIT 0.5 // period of checking the job
