class __attribute__((packed)) DummyStor : public Storable {
public:
	int val;
public:
	DummyStor();
	void save();
private:
	void setPtrs();
	void load_0();
};

DummyStor::DummyStor() :
	Storable(sizeof(DummyStor)),
	val(-1)
{
}

void DummyStor::save() {
	memcpy(getBuf(), this, sizeof(DummyStor));
}

void DummyStor::setPtrs() {
}

void DummyStor::load_0() {
	memcpy(this, getBuf(), sizeof(DummyStor));
}

void testDelay(double x, double time0) {
	mpiDelay(x);
	logTime("delay = " + toString(x), time0);
}

void testDelayA(double x, SharedMem &mem, double time0) {
	double t = MPI_Wtime();
	while (MPI_Wtime() - t < x) {
		mem.use();
	}
	logTime("active delay = " + toString(x), time0);
}

void testMutex(int passN) {
	int rank = mpiRank();
	logRow("");
	logRow("------- process " + toString(rank));
	Mutex mutex(TAG_MUTEX, true);
	DummyStor stor;
	SharedMem mem(stor.getBufN());
	if (rank == BOSS_RANK) {
		stor.val = passN;
		stor.rmaPut(mem);
	}
	mpiBarrier();
	double time0 = MPI_Wtime();
	logTime("barrier", time0);
	if (rank != BOSS_RANK) {
		stor.rmaGet(mem);
		logTime("begin, val = " + toString(stor.val), time0);
	}
	logTime("begin", time0);
	mpiBarrier();
	logTime("start", time0);
	while (stor.val) {
		mutex.lock();
		logTime("lock", time0);
		if (rank != BOSS_RANK) {
			testDelay(3, time0);
		}
		stor.rmaGet(mem);
		logTime("get, val = " + toString(stor.val), time0);
		if (stor.val) {
			stor.val--;
		}
		if (rank != BOSS_RANK) {
			testDelay(3, time0);
		}
		stor.rmaPut(mem);
		logTime("put, val = " + toString(stor.val), time0);
		mutex.unlock();
		logTime("unlock", time0);
		if (rank == BOSS_RANK) {
			testDelayA(10, mem, time0);
		}
	}
	mpiBarrier();
	logTime("end", time0);
	stor.rmaGet(mem);
	logTime("end, val = " + toString(stor.val), time0);
	logRow("");
	mpiBarrier();
	mpiAbort();
}
